
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Report related &#8212; Battery SOH 2022 documentation</title>
    
  <link href="../_static/css/theme.css" rel="stylesheet" />
  <link href="../_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="../_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/basic.css" />
    
  <link rel="preload" as="script" href="../_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Evaluating models from reports (backup)" href="Old_Load_Save.html" />
    <link rel="prev" title="Training and Simulation" href="Training.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="../index.html">
  <img src="../_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 current active nav-item">
 <a class="current reference internal nav-link" href="#">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="../search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    <ul class="nav bd-sidenav">
 <li class="toctree-l1">
  <a class="reference internal" href="Old_Load_Save.html">
   Evaluating models from reports (backup)
  </a>
 </li>
</ul>

  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
              
              <div class="toc-item">
                
<div class="tocsection onthispage pt-5 pb-3">
    <i class="fas fa-list"></i> On this page
</div>

<nav id="bd-toc-nav">
    <ul class="visible nav section-nav flex-column">
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#report-creation">
   Report creation
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#evaluating-models-from-reports">
   Evaluating models from reports
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#for-older-models">
   For older models
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#distribution-plots">
   Distribution plots
  </a>
 </li>
</ul>

</nav>
              </div>
              
              <div class="toc-item">
                
              </div>
              
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  <div class="section" id="report-related">
<h1>Report related<a class="headerlink" href="#report-related" title="Permalink to this headline">¶</a></h1>
<p>Here you’ll find the documentation for all functions related to the creation of a
report.</p>
<p>A report is created when you train a model using the <a class="reference internal" href="Training.html#Training.Train" title="Training.Train"><code class="xref py py-func docutils literal notranslate"><span class="pre">Training.Train()</span></code></a>.
The report folder is named with the time it was created -
in order to ensure that the user wouldn’t create reports with
the same name and overwrite them.</p>
<p>Inside the Train function, the <a class="reference internal" href="#Report.Report" title="Report.Report"><code class="xref py py-func docutils literal notranslate"><span class="pre">Report.Report()</span></code></a> function is called, which
will write down a text file with a summary of the training and save other model
files in the report folder. Notice that this function relies on the fact that the
classes defined in <a class="reference internal" href="Models.html"><span class="doc">Models</span></a> all have a <code class="docutils literal notranslate"><span class="pre">report()</span></code> method, which
outputs all of the important information needed to recreate it. <strong>If you intend
on developing new models, make sure you add such a method to their classes</strong>.
<a class="reference internal" href="Models.html#new-models"><span class="std std-ref">Here</span></a>, you’ll find all you have to do if you want to implement
new models.</p>
<p>Right after training, you’ll find the following files in the report folder by
default:</p>
<ul class="simple">
<li><p>A <code class="docutils literal notranslate"><span class="pre">'TEST_report.txt'</span></code> text file with information about the model, the
training epochs and the training and validation datasets. This is created
through the Report function. The file name can be changed by changing the
<code class="docutils literal notranslate"><span class="pre">file_name</span></code> option when calling the <a class="reference internal" href="Training.html#Training.Train" title="Training.Train"><code class="xref py py-func docutils literal notranslate"><span class="pre">Train()</span></code></a> function.
You can find an example of what this report looks like <a class="reference internal" href="code_examples.html#report-ex"><span class="std std-ref">here</span></a>.</p></li>
<li><p>Pickles ‘best_model.txt’ and ‘best_model_dict.txt’ which correspond to the
<strong>BEST</strong> epoch’s model and <code class="docutils literal notranslate"><span class="pre">state_dict</span></code> (only its parameters), respectively
(see <a class="reference external" href="https://pytorch.org/tutorials/beginner/saving_loading_models.html">PyTorch’s documentation  on how to load state_dicts</a> or
<a class="reference internal" href="code_examples.html#code-example-dict"><span class="std std-ref">this example</span></a>).</p></li>
<li><p>Pickles ‘base_model.txt’ and ‘base_model_dict.txt’ which correspond to the
<strong>last</strong> epoch’s model and <code class="docutils literal notranslate"><span class="pre">state_dict</span></code> (only its parameters), respectively.</p></li>
<li><p>An “Images” folder with an image of the training curve (“TEST_losses.png”) for
the training and validation datasets.</p></li>
<li><p>If the training function was called with <code class="docutils literal notranslate"><span class="pre">remove_bool=False</span></code>, then there
will also be a folder called “Epochs” with the model’s <code class="docutils literal notranslate"><span class="pre">state_dict</span></code> for each
individual epoch.</p></li>
<li><p>Pickles ‘<a href="#id12"><span class="problematic" id="id13">train_info_tuple_</span></a>.txt’ and ‘<a href="#id14"><span class="problematic" id="id15">valid_info_tuple_</span></a>.txt’ which are store
dataset information and are called by the <a class="reference internal" href="#module-Load_Save" title="Load_Save"><code class="xref py py-mod docutils literal notranslate"><span class="pre">Load_Save</span></code></a> functions.</p></li>
</ul>
<p>If you then call the <a class="reference internal" href="#Load_Save.Load_Save" title="Load_Save.Load_Save"><code class="xref py py-func docutils literal notranslate"><span class="pre">Load_Save()</span></code></a> function, folders
“Images_Best” (best epoch model) and “Images_Final” (last epoch model) will be
created with the plots of the model vs data points for each battery - batteries
from the training dataset will be distinguished from the rest in the plot title.
Files “Analysis_Best.txt” and “Analysis_Final.txt” will also be created, with
quantitative information about the model’s performance for each battery
(frankly, the most relevant information is on the line “Relative to the BoL
capacity:”).</p>
<p>If you then call the <a class="reference internal" href="#Load_Save.Load_Save_v2" title="Load_Save.Load_Save_v2"><code class="xref py py-func docutils literal notranslate"><span class="pre">Load_Save_v2()</span></code></a> function, something
similar is done, but the Images folder and Analysis file will include the name of
the dataset picked. <strong>It won’t distinguish batteries from the training and
validation datasets</strong>.</p>
<p><strong>NEW:</strong> You can now also call <a class="reference internal" href="#Table.table_from_report" title="Table.table_from_report"><code class="xref py py-func docutils literal notranslate"><span class="pre">Table.table_from_report()</span></code></a> on an analysis
file to create an excel spreadsheet with the information contained in it.
<strong>Be aware that it won’t distinguish batteries from the training and
validation datasets if the analysis file was created with</strong>
<a class="reference internal" href="#Load_Save.Load_Save_v2" title="Load_Save.Load_Save_v2"><code class="xref py py-func docutils literal notranslate"><span class="pre">Load_Save_v2()</span></code></a>.</p>
<div class="toctree-wrapper compound">
</div>
<div class="section" id="report-creation">
<h2>Report creation<a class="headerlink" href="#report-creation" title="Permalink to this headline">¶</a></h2>
<p>Corresponds to the <code class="docutils literal notranslate"><span class="pre">Report</span></code> module.</p>
<span class="target" id="module-Report"></span><dl class="py function">
<dt class="sig sig-object py" id="Report.Report">
<span class="sig-prename descclassname"><span class="pre">Report.</span></span><span class="sig-name descname"><span class="pre">Report</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">Model</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">train_loader</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">valid_loader</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">Training_info</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">file_name</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'Report'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">remove_files</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Report.html#Report"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Report.Report" title="Permalink to this definition">¶</a></dt>
<dd><p>This function creates a Report text file containing information about the
model’s training and saves important information in separate files.</p>
<p>This function is called by the <a class="reference internal" href="Training.html#Training.Train" title="Training.Train"><code class="xref py py-func docutils literal notranslate"><span class="pre">Training.Train()</span></code></a> function of the
<a class="reference internal" href="Training.html#module-Training" title="Training"><code class="xref py py-mod docutils literal notranslate"><span class="pre">Training</span></code></a> module at the end of the last epoch (if <code class="docutils literal notranslate"><span class="pre">report=True</span></code>).</p>
<p>The text report will include:</p>
<ul class="simple">
<li><p>Information about the model itself (specificities).</p></li>
<li><dl class="simple">
<dt>Training information.</dt><dd><p>Learning rate, number of epochs, batch size, best and last epochs and
their losses, loss function and optimizer.</p>
</dd>
</dl>
</li>
<li><p>Information about the training and validation datasets.</p></li>
</ul>
<p>This function will also save the best and last epochs’ models
(<cite>best_model.txt</cite> and <cite>base_model.txt</cite>) and the Training_Class object with
all of the training information.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>The model’s parameters are changed to the best epoch’s.</p>
</div>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>Model</strong> (<em>torch.nn.Module</em>) – The trained model.</p></li>
<li><p><strong>train_loader</strong> (<em>torch.utils.data.DataLoader</em>) – The training dataset’s DataLoader class.</p></li>
<li><p><strong>valid_loader</strong> (<em>torch.utils.data.DataLoader</em>) – The validation dataset’s DataLoader class.</p></li>
<li><p><strong>Training_info</strong> (<a class="reference internal" href="#Report.Training_Class" title="Report.Training_Class"><em>Training_Class</em></a><em>, </em><em>optional</em>) – The Training_Class where the training information is stored.</p></li>
<li><p><strong>file_name</strong> (<em>str</em><em>, </em><em>default = 'Report'</em>) – The name of the report file.</p></li>
<li><p><strong>remove_files</strong> (<em>bool</em><em>, </em><em>default = False</em>) – Whether or not to remove the Epochs’ files after saving the last and
best epochs’ results. This may be desirable if many epochs were run.</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="Report.Training_Class">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">Report.</span></span><span class="sig-name descname"><span class="pre">Training_Class</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">N_epochs</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">loss_fn</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">optimizer</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">learning_rate</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">batch_size</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Report.html#Training_Class"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Report.Training_Class" title="Permalink to this definition">¶</a></dt>
<dd><p>This class was created to keep track of training and epoch information.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>N_epochs</strong> (<em>int</em>) – Number of epochs in the training.</p></li>
<li><p><strong>loss_fn</strong> (<em>a torch.nn. Loss function</em>) – The loss function used in training.</p></li>
<li><p><strong>optimizer</strong> (<em>a torch.nn Optimizer</em>) – The optimizer used in training.</p></li>
<li><p><strong>learning_rate</strong> (<em>float</em>) – Training learning_rate.</p></li>
<li><p><strong>batch_size</strong> (<em>int</em>) – Training batch_size.</p></li>
</ul>
</dd>
</dl>
<dl class="py attribute">
<dt class="sig sig-object py" id="Report.Training_Class.nb_epochs">
<span class="sig-name descname"><span class="pre">nb_epochs</span></span><a class="headerlink" href="#Report.Training_Class.nb_epochs" title="Permalink to this definition">¶</a></dt>
<dd><p>The number of epochs.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>int</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Report.Training_Class.loss_fn">
<span class="sig-name descname"><span class="pre">loss_fn</span></span><a class="headerlink" href="#Report.Training_Class.loss_fn" title="Permalink to this definition">¶</a></dt>
<dd><p>The loss function used in training.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>a torch.nn. Loss function</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Report.Training_Class.optimizer">
<span class="sig-name descname"><span class="pre">optimizer</span></span><a class="headerlink" href="#Report.Training_Class.optimizer" title="Permalink to this definition">¶</a></dt>
<dd><p>The optimizer used in training.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>a torch.nn Optimizer</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Report.Training_Class.learning_rate">
<span class="sig-name descname"><span class="pre">learning_rate</span></span><a class="headerlink" href="#Report.Training_Class.learning_rate" title="Permalink to this definition">¶</a></dt>
<dd><p>Training learning_rate.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Report.Training_Class.batch_size">
<span class="sig-name descname"><span class="pre">batch_size</span></span><a class="headerlink" href="#Report.Training_Class.batch_size" title="Permalink to this definition">¶</a></dt>
<dd><p>Training batch_size.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>int</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Report.Training_Class.epoch">
<span class="sig-name descname"><span class="pre">epoch</span></span><a class="headerlink" href="#Report.Training_Class.epoch" title="Permalink to this definition">¶</a></dt>
<dd><p>A list of all of the training epochs. To add an epoch to this list, the
method <code class="docutils literal notranslate"><span class="pre">add_epoch</span></code> is used. See Epoch_Class for more.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>list[<a class="reference internal" href="#Report.Training_Class.Epoch_Class" title="Report.Training_Class.Epoch_Class">Epoch_Class</a>]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Report.Training_Class.best_epoch">
<span class="sig-name descname"><span class="pre">best_epoch</span></span><a class="headerlink" href="#Report.Training_Class.best_epoch" title="Permalink to this definition">¶</a></dt>
<dd><p>Epoch information about the best epoch. It is defined through the method
<code class="docutils literal notranslate"><span class="pre">best_epoch</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p><a class="reference internal" href="#Report.Training_Class.Epoch_Class" title="Report.Training_Class.Epoch_Class">Epoch_Class</a></p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Report.Training_Class.trains">
<span class="sig-name descname"><span class="pre">trains</span></span><a class="headerlink" href="#Report.Training_Class.trains" title="Permalink to this definition">¶</a></dt>
<dd><p>A list with the information of the previous times the model has been
trained. To add a Training_Class to the list, the method <code class="docutils literal notranslate"><span class="pre">add_epoch</span></code>
is used.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>list[<a class="reference internal" href="#Report.Training_Class" title="Report.Training_Class">Training_Class</a>]</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="Report.Training_Class.add_epoch">
<span class="sig-name descname"><span class="pre">add_epoch</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">train_loss</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">valid_loss</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">nb</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Report.html#Training_Class.add_epoch"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Report.Training_Class.add_epoch" title="Permalink to this definition">¶</a></dt>
<dd><p>Adds an epoch to self.epoch list. The epoch itself is a separate
Epoch_Class object.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>train_loss</strong> (<em>th.Tensor</em>) – The training dataset loss.</p></li>
<li><p><strong>valid_loss</strong> (<em>th.Tensor</em>) – The validation dataset loss.</p></li>
<li><p><strong>nb</strong> (<em>int</em>) – The epoch’s number</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="Report.Training_Class.best_epoch_method">
<span class="sig-name descname"><span class="pre">best_epoch_method</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Report.html#Training_Class.best_epoch_method"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Report.Training_Class.best_epoch_method" title="Permalink to this definition">¶</a></dt>
<dd><p>Calculates which epoch has the lowest validation loss and defines it
as the attribute best_epoch (Epoch_Class).</p>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="Report.Training_Class.add_train">
<span class="sig-name descname"><span class="pre">add_train</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">Training_info</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Report.html#Training_Class.add_train"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Report.Training_Class.add_train" title="Permalink to this definition">¶</a></dt>
<dd><p>Stores information from a past training when a model has already been
trained before.
Not very useful and not very well implemented, works just as a history
and is very rarely used.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>Training_info</strong> (<a class="reference internal" href="#Report.Training_Class" title="Report.Training_Class"><em>Training_Class</em></a>) – The training information we are aggregating.</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="Report.Training_Class.supplementary_information">
<span class="sig-name descname"><span class="pre">supplementary_information</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">string</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Report.html#Training_Class.supplementary_information"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Report.Training_Class.supplementary_information" title="Permalink to this definition">¶</a></dt>
<dd><p>Adds supplementary information to the report method.</p>
<blockquote>
<div><p>In order to adjust it to the formatting of the report, it’s recommended
to start the supplementary information with two spaces and skip a line
(‘</p>
</div></blockquote>
<p>‘) for each new item.</p>
<blockquote>
<div><dl class="simple">
<dt>string<span class="classifier">str</span></dt><dd><p>The string we want to add to the report method.</p>
</dd>
</dl>
</div></blockquote>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="Report.Training_Class.report">
<span class="sig-name descname"><span class="pre">report</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Report.html#Training_Class.report"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Report.Training_Class.report" title="Permalink to this definition">¶</a></dt>
<dd><p>Creates a little report with all of the information about the class.</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p></p>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p>A string with the report information.</p>
</dd>
</dl>
</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="Report.Training_Class.Epoch_Class">
<em class="property"><span class="pre">class</span> </em><span class="sig-name descname"><span class="pre">Epoch_Class</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">train_loss</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">valid_loss</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">nb</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Report.html#Training_Class.Epoch_Class"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Report.Training_Class.Epoch_Class" title="Permalink to this definition">¶</a></dt>
<dd><p>A class for keeping track of the training epochs.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>train_loss</strong> (<em>th.Tensor</em>) – The training dataset loss.</p></li>
<li><p><strong>valid_loss</strong> (<em>th.Tensor</em>) – The validation dataset loss.</p></li>
<li><p><strong>nb</strong> (<em>int</em>) – The epoch’s number</p></li>
</ul>
</dd>
</dl>
</dd></dl>

</dd></dl>

</div>
<div class="section" id="evaluating-models-from-reports">
<h2>Evaluating models from reports<a class="headerlink" href="#evaluating-models-from-reports" title="Permalink to this headline">¶</a></h2>
<p>Corresponds to the <code class="docutils literal notranslate"><span class="pre">Load_Save</span></code> and <code class="docutils literal notranslate"><span class="pre">Table</span></code> modules.</p>
<p>The <a class="reference internal" href="#Load_Save.Load_Save" title="Load_Save.Load_Save"><code class="xref py py-func docutils literal notranslate"><span class="pre">Load_Save()</span></code></a> function is older and should be harder to
adapt to new datasets and models (though not incredibly hard).
<a class="reference internal" href="#Load_Save.Load_Save_v2" title="Load_Save.Load_Save_v2"><code class="xref py py-func docutils literal notranslate"><span class="pre">Load_Save_v2()</span></code></a> is newer and should be easier. However, it
doesn’t distinguish training and validation batteries in the files it creates.</p>
<span class="target" id="module-Load_Save"></span><dl class="py function">
<dt class="sig sig-object py" id="Load_Save.Load_Save">
<span class="sig-prename descclassname"><span class="pre">Load_Save.</span></span><span class="sig-name descname"><span class="pre">Load_Save</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">report_name</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">device</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'cpu'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">plot_bool</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">analysis</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">epoch</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">dataset_name</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'NASA'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">report_bool</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">complete</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">denormalize_bool</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">base_capacity</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Load_Save.html#Load_Save"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Load_Save.Load_Save" title="Permalink to this definition">¶</a></dt>
<dd><p>Function for loading a report’s model and simulating its performance.</p>
<p>The function reaches into the report directory and loads both the best and
last epochs’ models. It also reads which batteries were used for training
and which were ignored (through the <em>load_info.txt</em> file).
It will then evaluate the model in each battery that hasn’t been
ignored and save an image of each result in folders <em>Images_Best</em> (for the
best epoch) and <em>Images_Final</em> (for the last epoch) inside of the original
report folder (<code class="docutils literal notranslate"><span class="pre">report_name</span></code>).</p>
<p>This function is perfect for being called just after training, for creating
the <code class="docutils literal notranslate"><span class="pre">analysis</span></code> file and plots.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>report_name</strong> (<em>str</em>) – The name of the report directory. It’s usually a date.</p></li>
<li><p><strong>device</strong> (<em>torch.device</em><em> or </em><em>str</em><em>, </em><em>default = 'cpu'</em>) – In which device the model and evaluation should be done.
Can either be ‘cpu’ or a cuda (‘cuda:0’, ‘cuda:1’, …).</p></li>
<li><p><strong>plot_bool</strong> (<em>bool</em><em>, </em><em>default = False</em>) – A boolean variable indicating whether or not to plot the battery
simulations as they are done.</p></li>
<li><p><strong>analysis</strong> (<em>bool</em><em>, </em><em>default = True</em>) – Whether or not to run a more individual analysis of the different
batteries.</p></li>
<li><p><strong>epoch</strong> (<em>int</em><em>, </em><em>optional</em>) – <p>The epoch number if the user wants to load the model’s parameter for
a specific epoch.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>This may not always be possible since the epoch’s folder is usually
deleted after training (see <a class="reference internal" href="Training.html#Training.Train" title="Training.Train"><code class="xref py py-func docutils literal notranslate"><span class="pre">Training.Train()</span></code></a>’s and
<a class="reference internal" href="#Report.Report" title="Report.Report"><code class="xref py py-func docutils literal notranslate"><span class="pre">Report.Report()</span></code></a>’s <code class="docutils literal notranslate"><span class="pre">remove_bool</span></code> variable).</p>
</div>
</p></li>
<li><p><strong>dataset_name</strong> (<em>{'NASA'</em><em>, </em><em>'MIT'</em><em>, </em><em>'Tarascon Coin'}</em>) – A string explaining which dataset to use.</p></li>
<li><p><strong>report_bool</strong> (<em>bool</em><em>, </em><em>default = True</em>) – A boolean variable for controlling whether or not to create the images
for each battery prediction.</p></li>
<li><p><strong>complete</strong> (<em>bool</em><em>, </em><em>default = False</em>) – Whether or not to run the analysis for all of the batteries in the
dataset (regardless of whether or not they were used in training and
validation).</p></li>
<li><p><strong>denormalize_bool</strong> (<em>bool</em><em>, </em><em>default = True</em>) – <p>Whether or not we want the plot to show the de-normalized values or not,
and whether or not to calculate the errors in function of the normalized
or denormalized values.</p>
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<p>Should be set to <code class="docutils literal notranslate"><span class="pre">False</span></code> for
<a class="reference internal" href="LSTMwithNorm.html"><span class="doc">LSTMs with norm</span></a>, since the output
denormalisation is already done inside the model. For others,
<code class="docutils literal notranslate"><span class="pre">True</span></code> is the best option.</p>
</div>
</p></li>
<li><p><strong>base_capacity</strong> (<em>float</em><em>, </em><em>optional</em>) – The nominal capacity to be used in the <a class="reference internal" href="#Load_Save.Analysis" title="Load_Save.Analysis"><code class="xref py py-func docutils literal notranslate"><span class="pre">Analysis()</span></code></a>
function. This should be defined only when using dimensional capacity
values for the model’s output.</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><ul class="simple">
<li><p><strong>NameError</strong> – When an unknown <code class="docutils literal notranslate"><span class="pre">dataset_name</span></code> or <code class="docutils literal notranslate"><span class="pre">model_name</span></code> is given.</p></li>
<li><p><strong>AttributeError</strong> – When the model does not have attribute <code class="docutils literal notranslate"><span class="pre">model_name</span></code>.</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="Load_Save.Load_Save_v2">
<span class="sig-prename descclassname"><span class="pre">Load_Save.</span></span><span class="sig-name descname"><span class="pre">Load_Save_v2</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">report_name</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">dataset_name</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">fixed_len</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">150</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">time_step</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">analysis</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">device</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'cpu'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">norm_test</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'dataset'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">Model</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">offset_analysis</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">cycle_lim</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1000000.0</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">denormalize_bool</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">base_capacity</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Load_Save.html#Load_Save_v2"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Load_Save.Load_Save_v2" title="Permalink to this definition">¶</a></dt>
<dd><p>Function for running analysing a model on different datasets.</p>
<p>The function takes a <code class="docutils literal notranslate"><span class="pre">report_name</span></code> as input, and accesses the report to
find the desired model. With <code class="docutils literal notranslate"><span class="pre">dataset_name</span></code>, it access the correct folder
for the dataset to test.</p>
<p>This function is different from <a class="reference internal" href="#Load_Save.Load_Save" title="Load_Save.Load_Save"><code class="xref py py-func docutils literal notranslate"><span class="pre">Load_Save()</span></code></a> because it can
apply a model to datasets different from the one it was trained on. The user
can also choose how the standardisation parameters will be calculated for
this dataset through the <code class="docutils literal notranslate"><span class="pre">norm_test</span></code> variable , although this won’t change
much for <a class="reference internal" href="LSTMwithNorm.html"><span class="doc">LSTMs with normalisation</span></a>, since in their
case the normalisation is done inside of the model and its parameters won’t
be affected.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>How to proceed when a <code class="docutils literal notranslate"><span class="pre">ModuleNotFoundError</span></code> is raised:
This is caused when a model trained with an older module tries to be
loaded. The older and newer models are compatible (the only thing that
changed between modules was only the <code class="docutils literal notranslate"><span class="pre">Torch_Dataset_LSTM</span></code> function).</p>
<p>In order to make this work, you’ll have to open the <cite>TEST_Report.txt</cite>
file in the desired report folder. It will contain all of the
information needed to initialize a similar model the parameters of which
can be replaced with the ones saved in the report.</p>
<p>In the <cite>TEST_Report.txt</cite> file, you’ll find something like this:</p>
<div class="highlight-text notranslate"><div class="highlight"><pre><span></span>MODEL
  Model name: LSTM
  Version: 4
  Dataset Format: You et al. [56]
  Delta: 10
  Hidden layer dimension: 50
  Pooling_layer: bi_mean
  Dropout prob.: 0
  Number of linear layers: 1
</pre></div>
</div>
<p>Define a model of the same version:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">model</span> <span class="o">=</span> <span class="n">LSTM_v4</span><span class="p">(</span><span class="n">Delta</span><span class="p">,</span> <span class="n">Hidden</span> <span class="n">layer</span> <span class="n">dimension</span><span class="p">,</span>
                <span class="n">pooling_layer</span><span class="o">=</span><span class="n">Pooling_layer</span><span class="p">,</span> <span class="n">drop_out</span><span class="o">=</span><span class="n">Dropout</span> <span class="n">prob</span><span class="o">.</span><span class="p">,</span>
                <span class="n">version</span><span class="o">=</span><span class="n">Version</span><span class="p">,</span> <span class="n">lin_layers</span><span class="o">=</span><span class="n">Number</span> <span class="n">of</span> <span class="n">linear</span> <span class="n">layers</span><span class="p">,</span>
                <span class="n">lin_dropout</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
</pre></div>
</div>
<p>(If <code class="docutils literal notranslate"><span class="pre">lin_dropout</span> <span class="pre">&gt;</span> <span class="pre">0</span></code>, an extra entry will be present in the report).
For versions 1 through 3, call <code class="xref py py-class docutils literal notranslate"><span class="pre">LSTM_v1</span></code> instead.
Then, just call this function again with variable <code class="docutils literal notranslate"><span class="pre">Model=model</span></code></p>
</div>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>report_name</strong> (<em>str</em>) – The name of the report folder inside the “Reports” folder.</p></li>
<li><p><strong>dataset_name</strong> (<em>{'NASA'</em><em>, </em><em>'MIT'</em><em>, </em><em>'Tarascon Coin'}</em>) – The name of the dataset to test the model on.</p></li>
<li><p><strong>fixed_len</strong> (<em>int</em><em>, </em><em>default = 150</em>) – The final length of the resampled charge curve data (in number of
points). See <code class="docutils literal notranslate"><span class="pre">Torch_Dataset_LSTM</span></code> in <cite>LSTM.py</cite> for more information.</p></li>
<li><p><strong>time_step</strong> (<em>float</em><em>, </em><em>optional</em>) – The desired time step for the resampling procedure.
If <code class="docutils literal notranslate"><span class="pre">None</span></code> is given, than a time step will be automatically generated
in function of the given <code class="docutils literal notranslate"><span class="pre">norm_test</span></code> variable.</p></li>
<li><p><strong>analysis</strong> (<em>bool</em><em>, </em><em>default = True</em>) – Whether or not to run a quantitative analysis of the dataset.
See <code class="docutils literal notranslate"><span class="pre">Analysis</span></code> function in <cite>Load_Save</cite> for more information.</p></li>
<li><p><strong>device</strong> (<em>torch.device</em><em> or </em><em>str</em><em>, </em><em>default = 'cpu'</em>) – In which device the model and evaluation should be done.
Can either be ‘cpu’ or a cuda (‘cuda:0’, ‘cuda:1’, …).</p></li>
<li><p><strong>norm_test</strong> (<em>str</em><em> or </em><em>list</em><em>(</em><em>str</em><em>)</em>) – <p>Informs how to calculate the normalization information to be used for
the data. It can be:</p>
<blockquote>
<div><p>”Model” : the model normalization will be used
“dataset” : the whole dataset will be used
list(str) : the batteries in the list</p>
<blockquote>
<div><p>Example: [‘B0001’, ‘B0005’, ‘B0025’]
Batteries 1, 5 and 25 from the dataset will be used.</p>
</div></blockquote>
</div></blockquote>
<p>If <code class="docutils literal notranslate"><span class="pre">time_step</span></code> is <code class="docutils literal notranslate"><span class="pre">None</span></code>, then the time_step will also be calculated
automatically for these batteries.</p>
</p></li>
<li><p><strong>Model</strong> (<em>torch.nn.Module</em><em>, </em><em>optional</em>) – A model to use as a base for loading the report’s parameters. This is
only necessary when trying to load a Model trained with an older module.
Check this function’s note for more information on how this should be
initialized.</p></li>
<li><p><strong>offset_analysis</strong> (<em>bool</em><em>, </em><em>optional</em>) – Whether or not to add an offset to the model’s bias term in order to
decrease the offset error.</p></li>
<li><p><strong>cycle_lim</strong> (<em>int</em><em>, </em><em>optional</em>) – The greatest cycle number to take into account for the dataset creation.
Default equals <code class="docutils literal notranslate"><span class="pre">1e6</span></code> meaning that no cycles will be ignored.</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><ul class="simple">
<li><p><strong>NameError</strong> – When an unknown <code class="docutils literal notranslate"><span class="pre">dataset_name</span></code>, model name or <code class="docutils literal notranslate"><span class="pre">norm_test</span></code> is given.</p></li>
<li><p><strong>ModuleNotFoundError</strong> – When an older module tries to be imported.</p></li>
<li><p><strong>AttributeError</strong> – When the model does not have attribute <code class="docutils literal notranslate"><span class="pre">variant</span></code>.</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="Load_Save.Analysis">
<span class="sig-prename descclassname"><span class="pre">Load_Save.</span></span><span class="sig-name descname"><span class="pre">Analysis</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">battery_loader_list</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">model</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">train</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">device</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'cpu'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">file_name</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">''</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">base_capacity</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">denormalize</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Load_Save.html#Analysis"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Load_Save.Analysis" title="Permalink to this definition">¶</a></dt>
<dd><p>Analyses the model’s performance over the different batteries.</p>
<p>Calculates the mean and maximum absolute error, mean and maximum relative
error, and the root mean squared error (RMSE).</p>
<p>A report will create a text file with the results.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>battery_loader_list</strong> (<em>list</em><em>[</em><em>torch.utils.data.DataLoader</em><em>]</em>) – The battery’s DataLoader loader.</p></li>
<li><p><strong>model</strong> (<em>torch.nn.Module</em>) – The model to use for the analysis.</p></li>
<li><p><strong>device</strong> (<em>torch.device</em><em> or </em><em>str</em><em>, </em><em>default = 'cpu'</em>) – In which device the model and evaluation should be done.
Can either be ‘cpu’ or a cuda (‘cuda:0’, ‘cuda:1’, …).</p></li>
<li><p><strong>file_name</strong> (<em>str</em>) – A string to add to the Analysis file name. The final name will be
‘Analysis’+file_name+’.txt’.</p></li>
<li><p><strong>base_capacity</strong> (<em>float</em><em>, </em><em>default = 1</em>) – The battery’s maximum capacity value (at its beginning of life).</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><strong>NotImplementedError</strong> – If the normalization type present in battery_loader.dataset.norm is not
    supported.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="Load_Save.offset_calculator">
<span class="sig-prename descclassname"><span class="pre">Load_Save.</span></span><span class="sig-name descname"><span class="pre">offset_calculator</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">Model</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">dataset</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">device</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'cpu'</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Load_Save.html#offset_calculator"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Load_Save.offset_calculator" title="Permalink to this definition">¶</a></dt>
<dd><p>Calculates the mean offset between prediction and experimental values.</p>
<p>This function will automatically update the model’s bias parameter in order
to decrease the offset.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Hasn’t been used in a long time.</p>
</div>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>Model</strong> (<em>torch.nn.Module</em>) – The Model to be analyzed and updated.</p></li>
<li><p><strong>dataset</strong> (<em>torch.utils.data.Dataset</em>) – The dataset to get the offset from.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p></p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>The model with updated bias parameter.</p>
</dd>
</dl>
</dd></dl>

<span class="target" id="module-Table"></span><dl class="py function">
<dt class="sig sig-object py" id="Table.table_from_report">
<span class="sig-prename descclassname"><span class="pre">Table.</span></span><span class="sig-name descname"><span class="pre">table_from_report</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">file_name</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Table.html#table_from_report"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Table.table_from_report" title="Permalink to this definition">¶</a></dt>
<dd><p>Creates an Excel Spreadsheet with model performance from an analysis file</p>
<p>The spreadsheet is saved in the respective report folder with the name of
the analysis file.</p>
<div class="figure align-default" id="id1" style="width: 50%">
<span id="figure-0"></span><img alt="../_images/table_example.png" src="../_images/table_example.png" />
<p class="caption"><span class="caption-text">Figure 0: Example of a table created with this function.</span><a class="headerlink" href="#id1" title="Permalink to this image">¶</a></p>
</div>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>file_name</strong> (<em>str</em>) – Name of the Analysis file (“Analysis_Best.txt”, “Analysis_MIT.txt” etc.)</p>
</dd>
</dl>
</dd></dl>

</div>
<div class="section" id="for-older-models">
<h2>For older models<a class="headerlink" href="#for-older-models" title="Permalink to this headline">¶</a></h2>
<p>If everything goes right, you won’t need to use this.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>If you get a <code class="docutils literal notranslate"><span class="pre">ModuleNotFoundError</span></code> while using
<a class="reference internal" href="#Load_Save.Load_Save" title="Load_Save.Load_Save"><code class="xref py py-func docutils literal notranslate"><span class="pre">Load_Save.Load_Save()</span></code></a> or <a class="reference internal" href="#Load_Save.Load_Save_v2" title="Load_Save.Load_Save_v2"><code class="xref py py-func docutils literal notranslate"><span class="pre">Load_Save.Load_Save_v2()</span></code></a>, you can
still use <a class="reference internal" href="#Load_Save.Load_Save_v2" title="Load_Save.Load_Save_v2"><code class="xref py py-func docutils literal notranslate"><span class="pre">Load_Save.Load_Save_v2()</span></code></a> for analysis. Check its
documentation for more.</p>
</div>
<div class="toctree-wrapper compound">
<ul>
<li class="toctree-l1"><a class="reference internal" href="Old_Load_Save.html">Evaluating models from reports (backup)</a></li>
</ul>
</div>
</div>
<div class="section" id="distribution-plots">
<span id="dist-plots"></span><h2>Distribution plots<a class="headerlink" href="#distribution-plots" title="Permalink to this headline">¶</a></h2>
<p>Corresponds to the <code class="docutils literal notranslate"><span class="pre">DistributionPlots</span></code> module. Contains two functions for
creating histograms and contour plots of the inputs’ distribution curves.</p>
<span class="target" id="module-DistributionPlots"></span><dl class="py function">
<dt class="sig sig-object py" id="DistributionPlots.dataset_jointplot">
<span class="sig-prename descclassname"><span class="pre">DistributionPlots.</span></span><span class="sig-name descname"><span class="pre">dataset_jointplot</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">dataset_name</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">full_dataset</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">fixed_len</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">150</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">norm</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">norm_type</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'zscore'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">cycle_lim</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1000000.0</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">delta</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">lstm_version</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">time_step</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">batteries</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/DistributionPlots.html#dataset_jointplot"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#DistributionPlots.dataset_jointplot" title="Permalink to this definition">¶</a></dt>
<dd><p>Function for creating joint plots of the different datasets.</p>
<p>The joint plots consist of a 2D scatter plot of the (t, V) couples, with
approximated distribution functions on the sides. An example is shown below.</p>
<div class="figure align-default" id="id2" style="width: 80%">
<img alt="Example of a joint plot." src="../_images/B0047.png" />
<p class="caption"><span class="caption-text">Example of a joint plot.</span><a class="headerlink" href="#id2" title="Permalink to this image">¶</a></p>
</div>
<p>This function does not support mixing different datsets (for it, check
<a class="reference internal" href="#DistributionPlots.dataset_displot" title="DistributionPlots.dataset_displot"><code class="xref py py-func docutils literal notranslate"><span class="pre">dataset_displot()</span></code></a>). This function can only create separate joint plots
for one or many batteries of a same dataset.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>dataset_name</strong> (<em>{'NASA'</em><em>, </em><em>'MIT'</em><em>, </em><em>'Tarascon Coin'}</em>) – String indicating which dataset we want to create the joint plot of.</p></li>
<li><p><strong>full_dataset</strong> (<em>bool</em>) – Whether or not we want to create a joint plot of the whole dataset in
one image (True) of one image for each battery (False).</p></li>
<li><p><strong>fixed_len</strong> (<em>int</em><em>, </em><em>optional</em>) – If different than <cite>None</cite> (default value), then the charge and discharge
curves will be limited to <cite>fixed_len</cite> points.</p></li>
<li><p><strong>norm_type</strong> (<em>{'zscore'</em><em>, </em><em>'minmax'}</em>) – A string indicating which kind of normalization to do.</p></li>
<li><p><strong>norm</strong> (<em>tuple</em><em>(</em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>string</em><em>)</em><em>, </em><em>optional</em>) – A tuple containing all of the information necessary for normalization.
If entered as input, <cite>norm_type</cite> will be overridden by norm[4] and the
given information will be used for the normalization</p></li>
<li><p><strong>cycle_lim</strong> (<em>int</em><em>, </em><em>optional</em>) – The greatest cycle number to take into account for the dataset creation.
Default equals <code class="docutils literal notranslate"><span class="pre">1e6</span></code> meaning that no cycles will be ignored.</p></li>
<li><p><strong>delta</strong> (<em>int</em><em>, </em><em>optional</em>) – The size of the sliding window used to generate the x_i’s.
This value only needs to be updated if the given <code class="docutils literal notranslate"><span class="pre">norm</span></code> is not
<code class="docutils literal notranslate"><span class="pre">None</span></code>, in which case shapes and sizes have to agree.
See <code class="docutils literal notranslate"><span class="pre">Torch_Dataset_LSTM</span></code>’s docstring in <cite>LSTM.py</cite> for more information.</p></li>
<li><p><strong>lstm_version</strong> (<em>int</em><em>, </em><em>optional</em>) – The LSTM’s version used for creating the normalisation parameters
(<code class="docutils literal notranslate"><span class="pre">norm</span></code>). This only needs to be given if <code class="docutils literal notranslate"><span class="pre">norm</span></code> is not <code class="docutils literal notranslate"><span class="pre">None</span></code>.</p></li>
<li><p><strong>time_step</strong> (<em>int</em><em>, </em><em>optional</em>) – The desired time step for the resampling procedure.
If <code class="docutils literal notranslate"><span class="pre">None</span></code> is given, than a time step will be automatically generated
by the method <code class="docutils literal notranslate"><span class="pre">time_step_function</span></code>.</p></li>
<li><p><strong>batteries</strong> (<em>list</em><em>[</em><em>str</em><em>]</em><em>, </em><em>optional</em>) – A list with the battery files’ names to create plots for. If <code class="docutils literal notranslate"><span class="pre">None</span></code>,
than all of the available batteries are used.</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><ul class="simple">
<li><p><strong>AssertionError</strong> – If the given <code class="docutils literal notranslate"><span class="pre">dataset_name</span></code> is not one of the valid ones.</p></li>
<li><p><strong>TypeError</strong> – If <code class="docutils literal notranslate"><span class="pre">fixed_len</span></code> is <code class="docutils literal notranslate"><span class="pre">None</span></code>.</p></li>
</ul>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">DistributionPlots</span> <span class="kn">import</span> <span class="o">*</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">dataset_jointplot</span><span class="p">(</span><span class="s1">&#39;NASA&#39;</span><span class="p">,</span> <span class="n">batteries</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;B0005.txt&#39;</span><span class="p">])</span>
<span class="go">32.532073974609375      # Calculated time step</span>
<span class="go">B0005                   # Battery currently analysing</span>
<span class="go">165                     # Number of capacity points</span>
<span class="go"># Plot saved in &#39;.//Datasets/NASA/B. Saha and K Goebel/Separate_pickles&#39;:</span>
</pre></div>
</div>
<div class="figure align-default" id="id3" style="width: 80%">
<img alt="The plot created" src="../_images/B0005.png" />
<p class="caption"><span class="caption-text">Plot saved as “B0005.png”</span><a class="headerlink" href="#id3" title="Permalink to this image">¶</a></p>
</div>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="DistributionPlots.dataset_displot">
<span class="sig-prename descclassname"><span class="pre">DistributionPlots.</span></span><span class="sig-name descname"><span class="pre">dataset_displot</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">battery_lists</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">[None,</span> <span class="pre">None,</span> <span class="pre">None]</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">twoD</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">norm_list</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">[None,</span> <span class="pre">None,</span> <span class="pre">None]</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">delta</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">lstm_version</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">norm_type</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'zscore'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">cycle_lim</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1000000.0</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">fixed_len</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">150</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">time_step</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">kind</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'hist'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">image_name</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">ignore_dict</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">yscale</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'linear'</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/DistributionPlots.html#dataset_displot"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#DistributionPlots.dataset_displot" title="Permalink to this definition">¶</a></dt>
<dd><p>Function for creating histogram distributions of the different datasets.</p>
<p>This function creates histograms and contour plots for comparing the
different datasets’ distributions.</p>
<div class="figure align-default" id="id4" style="width: 80%">
<img alt="Example of an histogram plot (``kind = 'hist'``, ``twoD=False``)" src="../_images/Figure_4.png" />
<p class="caption"><span class="caption-text">Example of an histogram plot (<code class="docutils literal notranslate"><span class="pre">kind</span> <span class="pre">=</span> <span class="pre">'hist'</span></code>, <code class="docutils literal notranslate"><span class="pre">twoD=False</span></code>)</span><a class="headerlink" href="#id4" title="Permalink to this image">¶</a></p>
</div>
<div class="figure align-default" id="id5" style="width: 80%">
<img alt="Example of a countour plot (``kind = 'kde'``, ``twoD=True``)" src="../_images/Figure_3.png" />
<p class="caption"><span class="caption-text">Example of a countour plot (<code class="docutils literal notranslate"><span class="pre">kind</span> <span class="pre">=</span> <span class="pre">'kde'</span></code>, <code class="docutils literal notranslate"><span class="pre">twoD=True</span></code>)</span><a class="headerlink" href="#id5" title="Permalink to this image">¶</a></p>
</div>
<p>It takes as inputs a list of lists with the batteries to include in the
histograms. It should be structured as follows:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">battery_lists</span> <span class="o">=</span> <span class="p">[</span>
    <span class="p">[</span><span class="s1">&#39;B0005.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0006.txt&#39;</span><span class="p">],</span>     <span class="c1"># Nasa Batteries</span>
    <span class="p">[</span><span class="s1">&#39;B0047.txt&#39;</span><span class="p">],</span>                  <span class="c1"># MIT Batteries</span>
    <span class="p">[</span><span class="s1">&#39;B0001.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0004.txt&#39;</span><span class="p">]</span>      <span class="c1"># Tarascon&#39;s Coin Batteries</span>
<span class="p">]</span>
</pre></div>
</div>
<p>If all of the dataset’s batteries are to be used, then a simple <code class="docutils literal notranslate"><span class="pre">None</span></code>
can be passed instead of a list. <strong>If no batteries are to be used, an emtpy
list must be passed</strong>.</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">battery_lists</span> <span class="o">=</span> <span class="p">[</span>
    <span class="kc">None</span><span class="p">,</span>                           <span class="c1"># ALL of Nasa&#39;s Batteries</span>
    <span class="p">[],</span>                             <span class="c1"># None of MIT Batteries</span>
    <span class="p">[</span><span class="s1">&#39;B0001.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0004.txt&#39;</span><span class="p">]</span>      <span class="c1"># Tarascon&#39;s Coin Batteries</span>
<span class="p">]</span>
</pre></div>
</div>
<p>By default, each dataset is normalized separately on its own. If you want to
specify the normalisation parameters, you can use input <code class="docutils literal notranslate"><span class="pre">norm_list</span></code> for
that:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">norm_nasa</span> <span class="o">=</span> <span class="p">(</span><span class="n">th</span><span class="o">.</span><span class="n">Tensor</span><span class="p">([</span><span class="mf">1.9</span><span class="p">,</span> <span class="mf">4.3</span><span class="p">]),</span> <span class="n">th</span><span class="o">.</span><span class="n">Tensor</span><span class="p">([</span><span class="mf">0.01</span><span class="p">,</span> <span class="mf">0.4</span><span class="p">]),</span>
             <span class="n">th</span><span class="o">.</span><span class="n">Tensor</span><span class="p">([</span><span class="mf">0.8</span><span class="p">]),</span> <span class="n">th</span><span class="o">.</span><span class="n">Tensor</span><span class="p">([</span><span class="mf">0.04</span><span class="p">]),</span> <span class="s1">&#39;zscore&#39;</span><span class="p">)</span>
<span class="n">norm_list</span> <span class="o">=</span> <span class="p">[</span>
    <span class="n">norm_nasa</span><span class="p">,</span>      <span class="c1"># Nasa dataset will be normalised with norm_nasa</span>
    <span class="kc">None</span><span class="p">,</span>           <span class="c1"># MIT dataset will be normalised with respect to itself</span>
    <span class="kc">None</span>            <span class="c1"># Same as MIT for Tarascon&#39;s Coin batteries.</span>
<span class="p">]</span>
</pre></div>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Make sure the value of <code class="docutils literal notranslate"><span class="pre">delta</span></code> and <code class="docutils literal notranslate"><span class="pre">lstm_version</span></code> are in accordance
with the normalisation information provided.</p>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>When inputting a <code class="docutils literal notranslate"><span class="pre">norm</span></code> in <code class="docutils literal notranslate"><span class="pre">norm_list</span></code>, the input <code class="docutils literal notranslate"><span class="pre">norm_type</span></code> will
automatically be overridden by <code class="docutils literal notranslate"><span class="pre">Torch_Dataset_LSTM</span></code>, but only for the
dataset for which the normalisation parameters were specified.</p>
</div>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>battery_lists</strong> (<em>list</em><em>[</em><em>list</em><em>[</em><em>str</em><em>]</em><em>]</em><em>, </em><em>optional</em>) – <p>List with three lists (of strings). The first list corresponds to the
batteries for the Nasa dataset, the second one for the MIT dataset and
the last one for Tarascon’s Coin dataset.
Each list is composed of several strings with the name of the battery
files, in the format “B0025.txt” (<code class="docutils literal notranslate"><span class="pre">'B'+str(number).zfill(4)+'.txt'</span></code>).</p>
<p>By default, it will use all of the available batteries for all datasets.</p>
</p></li>
<li><p><strong>twoD</strong> (<em>bool</em>) – Whether or not to create a 2D distribution (V x t).</p></li>
<li><p><strong>norm_list</strong> (<em>list</em><em>[</em><em>tuple</em><em>]</em>) – A list with the normalisation information for each dataset.
See function <code class="docutils literal notranslate"><span class="pre">Normalize</span></code> in <code class="docutils literal notranslate"><span class="pre">Cleaning.py</span></code> for more information on
how this information is structured.</p></li>
<li><p><strong>norm_type</strong> (<em>{'zscore'</em><em>, </em><em>'minmax'}</em>) – A string indicating which kind of normalization to do.</p></li>
<li><p><strong>cycle_lim</strong> (<em>int</em><em>, </em><em>optional</em>) – The greatest cycle number to take into account for the dataset creation.
Default equals <code class="docutils literal notranslate"><span class="pre">1e6</span></code> meaning that no cycles will be ignored.</p></li>
<li><p><strong>fixed_len</strong> (<em>int</em><em>, </em><em>optional</em>) – If different than <cite>None</cite> (default value), then the charge and discharge
curves will be limited to <cite>fixed_len</cite> points.</p></li>
<li><p><strong>kind</strong> (<em>str</em><em>, </em><em>default = 'hist'</em>) – The kind of seaborn plot to create. Check seaborn’s <code class="docutils literal notranslate"><span class="pre">displot</span></code>
documentation for more information.</p></li>
<li><p><strong>image_name</strong> (<em>str</em><em>, </em><em>optional</em>) – If an image_name is given, then the image will be saved as a png file
with that name.</p></li>
<li><p><strong>yscale</strong> (<em>str</em><em>, </em><em>default = 'linear'</em>) – The y-axis scale (‘linear’ is regular and ‘log’ for log scale’).</p></li>
</ul>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">DistributionPlots</span> <span class="kn">import</span> <span class="o">*</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">dataset_displot</span><span class="p">(</span><span class="n">battery_lists</span><span class="o">=</span><span class="p">[[</span><span class="s1">&#39;B0005.txt&#39;</span><span class="p">],</span> <span class="p">[],</span> <span class="kc">None</span><span class="p">])</span>
<span class="gp">... </span><span class="c1"># Nasa&#39;s Battery Nº5, no batteries from MIT&#39;s dataset, All of Tarascon&#39;s</span>
<span class="gp">... </span><span class="c1"># batteries</span>
<span class="gp">... </span><span class="c1"># See Figure 3_ for results</span>
</pre></div>
</div>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Reports/2021-07-12 09_28_11.807309&#39;</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="c1"># LSTM_v4 trained with Nasa dataset</span>
<span class="gp">&gt;&gt;&gt; </span><span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;best_model.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
<span class="gp">... </span>    <span class="n">Model</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
<span class="gp">...</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">nasa_norm</span> <span class="o">=</span> <span class="n">Model</span><span class="o">.</span><span class="n">norm</span>      <span class="c1"># Taking the model&#39;s norm</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">dataset_displot</span><span class="p">(</span><span class="n">battery_lists</span><span class="o">=</span><span class="p">[</span>
<span class="gp">... </span>     <span class="p">[</span><span class="s1">&#39;B0005.txt&#39;</span><span class="p">],</span> <span class="p">[</span><span class="s1">&#39;B0047.txt&#39;</span><span class="p">],</span> <span class="p">[</span><span class="s1">&#39;B0001.txt&#39;</span><span class="p">]</span>
<span class="gp">... </span><span class="p">],</span> <span class="n">twoD</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">kind</span><span class="o">=</span><span class="s1">&#39;kde&#39;</span><span class="p">,</span>
<span class="gp">... </span><span class="n">norm_list</span><span class="o">=</span><span class="p">[</span><span class="n">nasa_norm</span><span class="p">,</span> <span class="n">nasa_norm</span><span class="p">,</span> <span class="n">nasa_norm</span><span class="p">],</span> <span class="c1"># datasets normalized with the same norm</span>
<span class="gp">... </span><span class="n">lstm_version</span><span class="o">=</span><span class="mi">4</span><span class="p">,</span> <span class="n">delta</span><span class="o">=</span><span class="mi">10</span><span class="p">)</span> <span class="c1"># LSTM version and delta have to match the norm&#39;s.</span>
<span class="gp">... </span><span class="c1"># See Figure 4 for results</span>
</pre></div>
</div>
<div class="figure align-default" id="id6" style="width: 80%">
<span id="figure-3"></span><img alt="../_images/Figure_1.png" src="../_images/Figure_1.png" />
<p class="caption"><span class="caption-text">Figure 3: Result of first example.</span><a class="headerlink" href="#id6" title="Permalink to this image">¶</a></p>
</div>
<div class="figure align-default" id="id7" style="width: 80%">
<span id="figure-4"></span><img alt="../_images/Figure_2.png" src="../_images/Figure_2.png" />
<p class="caption"><span class="caption-text">Figure 4: Result of the second example.</span><a class="headerlink" href="#id7" title="Permalink to this image">¶</a></p>
</div>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="DistributionPlots.SOH_displot">
<span class="sig-prename descclassname"><span class="pre">DistributionPlots.</span></span><span class="sig-name descname"><span class="pre">SOH_displot</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">battery_lists</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">[None,</span> <span class="pre">None,</span> <span class="pre">None]</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">twoD</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">norm_list</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">[None,</span> <span class="pre">None,</span> <span class="pre">None]</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">delta</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">lstm_version</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">norm_type</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'zscore'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">cycle_lim</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1000000.0</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">fixed_len</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">150</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">time_step</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">kind</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'hist'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">image_name</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">ignore_dict</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/DistributionPlots.html#SOH_displot"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#DistributionPlots.SOH_displot" title="Permalink to this definition">¶</a></dt>
<dd><p>Function for creating histogram distributions of the different datasets.</p>
<p>This function creates histograms and contour plots for comparing the
different datasets’ distributions.</p>
<div class="figure align-default" id="id8" style="width: 80%">
<img alt="Example of an histogram plot (``kind = 'hist'``, ``twoD=False``)" src="../_images/Figure_4.png" />
<p class="caption"><span class="caption-text">Example of an histogram plot (<code class="docutils literal notranslate"><span class="pre">kind</span> <span class="pre">=</span> <span class="pre">'hist'</span></code>, <code class="docutils literal notranslate"><span class="pre">twoD=False</span></code>)</span><a class="headerlink" href="#id8" title="Permalink to this image">¶</a></p>
</div>
<div class="figure align-default" id="id9" style="width: 80%">
<img alt="Example of a countour plot (``kind = 'kde'``, ``twoD=True``)" src="../_images/Figure_3.png" />
<p class="caption"><span class="caption-text">Example of a countour plot (<code class="docutils literal notranslate"><span class="pre">kind</span> <span class="pre">=</span> <span class="pre">'kde'</span></code>, <code class="docutils literal notranslate"><span class="pre">twoD=True</span></code>)</span><a class="headerlink" href="#id9" title="Permalink to this image">¶</a></p>
</div>
<p>It takes as inputs a list of lists with the batteries to include in the
histograms. It should be structured as follows:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">battery_lists</span> <span class="o">=</span> <span class="p">[</span>
    <span class="p">[</span><span class="s1">&#39;B0005.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0006.txt&#39;</span><span class="p">],</span>     <span class="c1"># Nasa Batteries</span>
    <span class="p">[</span><span class="s1">&#39;B0047.txt&#39;</span><span class="p">],</span>                  <span class="c1"># MIT Batteries</span>
    <span class="p">[</span><span class="s1">&#39;B0001.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0004.txt&#39;</span><span class="p">]</span>      <span class="c1"># Tarascon&#39;s Coin Batteries</span>
<span class="p">]</span>
</pre></div>
</div>
<p>If all of the dataset’s batteries are to be used, then a simple <code class="docutils literal notranslate"><span class="pre">None</span></code>
can be passed instead of a list. <strong>If no batteries are to be used, an emtpy
list must be passed</strong>.</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">battery_lists</span> <span class="o">=</span> <span class="p">[</span>
    <span class="kc">None</span><span class="p">,</span>                           <span class="c1"># ALL of Nasa&#39;s Batteries</span>
    <span class="p">[],</span>                             <span class="c1"># None of MIT Batteries</span>
    <span class="p">[</span><span class="s1">&#39;B0001.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0004.txt&#39;</span><span class="p">]</span>      <span class="c1"># Tarascon&#39;s Coin Batteries</span>
<span class="p">]</span>
</pre></div>
</div>
<p>By default, each dataset is normalized separately on its own. If you want to
specify the normalisation parameters, you can use input <code class="docutils literal notranslate"><span class="pre">norm_list</span></code> for
that:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">norm_nasa</span> <span class="o">=</span> <span class="p">(</span><span class="n">th</span><span class="o">.</span><span class="n">Tensor</span><span class="p">([</span><span class="mf">1.9</span><span class="p">,</span> <span class="mf">4.3</span><span class="p">]),</span> <span class="n">th</span><span class="o">.</span><span class="n">Tensor</span><span class="p">([</span><span class="mf">0.01</span><span class="p">,</span> <span class="mf">0.4</span><span class="p">]),</span>
             <span class="n">th</span><span class="o">.</span><span class="n">Tensor</span><span class="p">([</span><span class="mf">0.8</span><span class="p">]),</span> <span class="n">th</span><span class="o">.</span><span class="n">Tensor</span><span class="p">([</span><span class="mf">0.04</span><span class="p">]),</span> <span class="s1">&#39;zscore&#39;</span><span class="p">)</span>
<span class="n">norm_list</span> <span class="o">=</span> <span class="p">[</span>
    <span class="n">norm_nasa</span><span class="p">,</span>      <span class="c1"># Nasa dataset will be normalised with norm_nasa</span>
    <span class="kc">None</span><span class="p">,</span>           <span class="c1"># MIT dataset will be normalised with respect to itself</span>
    <span class="kc">None</span>            <span class="c1"># Same as MIT for Tarascon&#39;s Coin batteries.</span>
<span class="p">]</span>
</pre></div>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Make sure the value of <code class="docutils literal notranslate"><span class="pre">delta</span></code> and <code class="docutils literal notranslate"><span class="pre">lstm_version</span></code> are in accordance
with the normalisation information provided.</p>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>When inputting a <code class="docutils literal notranslate"><span class="pre">norm</span></code> in <code class="docutils literal notranslate"><span class="pre">norm_list</span></code>, the input <code class="docutils literal notranslate"><span class="pre">norm_type</span></code> will
automatically be overridden by <code class="docutils literal notranslate"><span class="pre">Torch_Dataset_LSTM</span></code>, but only for the
dataset for which the normalisation parameters were specified.</p>
</div>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>battery_lists</strong> (<em>list</em><em>[</em><em>list</em><em>[</em><em>str</em><em>]</em><em>]</em><em>, </em><em>optional</em>) – <p>List with three lists (of strings). The first list corresponds to the
batteries for the Nasa dataset, the second one for the MIT dataset and
the last one for Tarascon’s Coin dataset.
Each list is composed of several strings with the name of the battery
files, in the format “B0025.txt” (<code class="docutils literal notranslate"><span class="pre">'B'+str(number).zfill(4)+'.txt'</span></code>).</p>
<p>By default, it will use all of the available batteries for all datasets.</p>
</p></li>
<li><p><strong>twoD</strong> (<em>bool</em>) – Whether or not to create a 2D distribution (V x t).</p></li>
<li><p><strong>norm_list</strong> (<em>list</em><em>[</em><em>tuple</em><em>]</em>) – A list with the normalisation information for each dataset.
See function <code class="docutils literal notranslate"><span class="pre">Normalize</span></code> in <code class="docutils literal notranslate"><span class="pre">Cleaning.py</span></code> for more information on
how this information is structured.</p></li>
<li><p><strong>norm_type</strong> (<em>{'zscore'</em><em>, </em><em>'minmax'}</em>) – A string indicating which kind of normalization to do.</p></li>
<li><p><strong>cycle_lim</strong> (<em>int</em><em>, </em><em>optional</em>) – The greatest cycle number to take into account for the dataset creation.
Default equals <code class="docutils literal notranslate"><span class="pre">1e6</span></code> meaning that no cycles will be ignored.</p></li>
<li><p><strong>fixed_len</strong> (<em>int</em><em>, </em><em>optional</em>) – If different than <cite>None</cite> (default value), then the charge and discharge
curves will be limited to <cite>fixed_len</cite> points.</p></li>
<li><p><strong>kind</strong> (<em>str</em><em>, </em><em>default = 'hist'</em>) – The kind of seaborn plot to create. Check seaborn’s <code class="docutils literal notranslate"><span class="pre">displot</span></code>
documentation for more information.</p></li>
<li><p><strong>image_name</strong> (<em>str</em><em>, </em><em>optional</em>) – If an image_name is given, then the image will be saved as a png file
with that name.</p></li>
</ul>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">DistributionPlots</span> <span class="kn">import</span> <span class="o">*</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">dataset_displot</span><span class="p">(</span><span class="n">battery_lists</span><span class="o">=</span><span class="p">[[</span><span class="s1">&#39;B0005.txt&#39;</span><span class="p">],</span> <span class="p">[],</span> <span class="kc">None</span><span class="p">])</span>
<span class="gp">... </span><span class="c1"># Nasa&#39;s Battery Nº5, no batteries from MIT&#39;s dataset, All of Tarascon&#39;s</span>
<span class="gp">... </span><span class="c1"># batteries</span>
<span class="gp">... </span><span class="c1"># See Figure 1 for results</span>
</pre></div>
</div>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Reports/2021-07-12 09_28_11.807309&#39;</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="c1"># LSTM_v4 trained with Nasa dataset</span>
<span class="gp">&gt;&gt;&gt; </span><span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;best_model.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
<span class="gp">... </span>    <span class="n">Model</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
<span class="gp">...</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">nasa_norm</span> <span class="o">=</span> <span class="n">Model</span><span class="o">.</span><span class="n">norm</span>      <span class="c1"># Taking the model&#39;s norm</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">dataset_displot</span><span class="p">(</span><span class="n">battery_lists</span><span class="o">=</span><span class="p">[</span>
<span class="gp">... </span>     <span class="p">[</span><span class="s1">&#39;B0005.txt&#39;</span><span class="p">],</span> <span class="p">[</span><span class="s1">&#39;B0047.txt&#39;</span><span class="p">],</span> <span class="p">[</span><span class="s1">&#39;B0001.txt&#39;</span><span class="p">]</span>
<span class="gp">... </span><span class="p">],</span> <span class="n">twoD</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">kind</span><span class="o">=</span><span class="s1">&#39;kde&#39;</span><span class="p">,</span>
<span class="gp">... </span><span class="n">norm_list</span><span class="o">=</span><span class="p">[</span><span class="n">nasa_norm</span><span class="p">,</span> <span class="n">nasa_norm</span><span class="p">,</span> <span class="n">nasa_norm</span><span class="p">],</span> <span class="c1"># datasets normalized with the same norm</span>
<span class="gp">... </span><span class="n">lstm_version</span><span class="o">=</span><span class="mi">4</span><span class="p">,</span> <span class="n">delta</span><span class="o">=</span><span class="mi">10</span><span class="p">)</span> <span class="c1"># LSTM version and delta have to match the norm&#39;s.</span>
<span class="gp">... </span><span class="c1"># See Figure 2 for results</span>
</pre></div>
</div>
<div class="figure align-default" id="id10" style="width: 80%">
<span id="figure-1"></span><img alt="../_images/Figure_1.png" src="../_images/Figure_1.png" />
<p class="caption"><span class="caption-text">Figure 1: Result of first example.</span><a class="headerlink" href="#id10" title="Permalink to this image">¶</a></p>
</div>
<div class="figure align-default" id="id11" style="width: 80%">
<span id="figure-2"></span><img alt="../_images/Figure_2.png" src="../_images/Figure_2.png" />
<p class="caption"><span class="caption-text">Figure 2: Result of the second example.</span><a class="headerlink" href="#id11" title="Permalink to this image">¶</a></p>
</div>
</dd></dl>

</div>
</div>


              </div>
              
              
              <div class='prev-next-bottom'>
                
    <a class='left-prev' id="prev-link" href="Training.html" title="previous page">Training and Simulation</a>
    <a class='right-next' id="next-link" href="Old_Load_Save.html" title="next page">Evaluating models from reports (backup)</a>

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="../_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2022, Antonio ROCHA AZEVEDO.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>